/************************************

fUnitCost overloaded jadi 2 param: 
	a. 5 params (pakai Qty)
	b. 4 params (tanpa Qty, dianggap Qty1)

*************************************/


CREATE OR REPLACE FUNCTION fUnitCost(
	_ItemID 	VARCHAR(20),
	_WhID 		VARCHAR(3),
	_PID 		VARCHAR(25),
	_Qty		DECIMAL(15,4),
	_Unit 		VARCHAR(5)
) RETURNS NUMERIC(19,4) AS 
$BODY$
DECLARE
	_retval			NUMERIC(19,4);

	_ItemType		VARCHAR(5);
	_IsStock		BOOLEAN;
	_IsAsm			BOOLEAN;
	_IsMfg			BOOLEAN;
	_BoMID			VARCHAR(20);
	_Unit1			VARCHAR(5);
	_Conv			NUMERIC(15,4);		/* Multiply Factor from UnitX to Unit1 */
	_BoMDItemID		VARCHAR(15);
	_BoMDWhID		VARCHAR(3);
	_BoMDQty		NUMERIC(15,4);
	_BoMDUnit		VARCHAR(5);
	_BoMD_ItemCost		NUMERIC(40,20);		/*-- Cost 1PCS item detail BoM*/
	_BoM_ItemsCost		NUMERIC(40,20);		/*-- Total cost untuk 1 set(UNIT1) Item BoM*/

	_CostUnit1		NUMERIC(40,20);
	_stock_SubTotal		DECIMAL(40,20);
	_stock_Qty		DECIMAL(15,4);

	cBoMD			REFCURSOR;

	_AvgCost		NUMERIC(19,4);

	_Multiplier		NUMERIC(19,4);
	_BomItemID		VARCHAR;
	_BomQty			NUMERIC(19,4);
	_BomUnit		VARCHAR;
BEGIN

	SELECT INTO 
		_ItemType,_IsMfg,_Unit1,_IsStock 
		ItemType,IsMfg,Unit1,IsStock
	FROM Item WHERE ItemID=_ItemID;

	-- read qty conversion
	_Conv:=fItemUnit_Conv(_ItemID, _Unit);

	IF (_IsStock=TRUE) THEN	-- Item Normal
		IF _PID IS NULL THEN
			SELECT INTO 
				_stock_SubTotal, _stock_Qty, _AvgCost 
				SubTotal, Qty, avgcost
			FROM Stock 
			WHERE ItemID=_ItemID AND WhID=_WhID;
		ELSE
			SELECT INTO 
				_stock_SubTotal, _stock_Qty, _AvgCost 
				SubTotal, Qty, avgcost 
			FROM Stock 
			WHERE ItemID=_ItemID AND WhID=_WhID AND PID=_PID;
		END IF;

		IF NOT FOUND THEN
			RETURN NULL;
		END IF;

		IF (_stock_Qty<>0) THEN
			_CostUnit1:=_Qty*_Conv*_stock_SubTotal/_stock_Qty;
		ELSE
			_CostUnit1:=_Qty*_Conv*_AvgCost;
		END IF;

		IF (_CostUnit1 IS NULL) THEN
			RETURN NULL;
		END IF;
	ELSIF (_ItemType='PACK' OR _IsAsm=TRUE) THEN /** item produksi atau paket */
		_BoM_ItemsCost:=0;
		SELECT INTO _BoMID, _BomQty, _BomUnit bomid, qty, unit FROM bom WHERE itemid=_ItemID AND pid=COALESCE(_PID, '') AND active=TRUE;
		IF FOUND THEN
			_BoM_ItemsCost:=0;

			_BomQty:=fQtyZToQty1(_ItemID, _BomQty, _BomUnit);
			_Multiplier:=fQtyZToQty1(_ItemID, _Qty, _Unit)/_BomQty;
			OPEN cBoMD FOR
				SELECT ItemID, WhID, Qty, Unit FROM BoMD WHERE BoMID=_BoMID;
			LOOP
				FETCH cBoMD INTO _BoMDItemID, _BoMDWhID, _BoMDQty, _BoMDUnit;
				EXIT WHEN NOT FOUND;

				SELECT INTO _BoMD_ItemCost * FROM fUnitCost(_BoMDItemID, _WhID, null, _BomDQty*_Conv*_Multiplier, _BoMDUnit);
				_BoM_ItemsCost=_BoM_ItemsCost+(_BoMD_ItemCost);
			END LOOP;
			CLOSE cBoMD;
		END IF;

		_CostUnit1:=_BoM_ItemsCost;

	ELSIF (_ItemType='SERV') THEN 
		_CostUnit1:=0;
	ELSE
		_CostUnit1:=0;
	END IF;

	_retval:=_CostUnit1;
	RETURN _retval;
END;
$BODY$ 
LANGUAGE 'plpgsql' VOLATILE;


/******************************************************************************************/
/*************************************** OVERLOAD-1 ***************************************/
/******************************************************************************************/

CREATE OR REPLACE FUNCTION fUnitCost(
	_ItemID		VARCHAR(20),
	_WhID		VARCHAR(3),
	_PID		VARCHAR(25),
	_Unit		VARCHAR(5)
) RETURNS DECIMAL(19,4) AS 
$BODY$
DECLARE
	_retval		DECIMAL(19,4);
BEGIN
	_retval:=fUnitCost(_ItemID, _WhID, _PID, 1, _Unit);

	RETURN _retval;
END
$BODY$ 
LANGUAGE 'plpgsql' VOLATILE;


